Index: trunk/source/processes/electromagnetic/adjoint/src/G4AdjointPhotoElectricModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4AdjointPhotoElectricModel.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4AdjointPhotoElectricModel.cc	(revision 1196)
@@ -24,4 +24,7 @@
 // ********************************************************************
 //
+// $Id: G4AdjointPhotoElectricModel.cc,v 1.4 2009/11/20 10:31:20 ldesorgh Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
 #include "G4AdjointPhotoElectricModel.hh"
 #include "G4AdjointCSManager.hh"
@@ -35,4 +38,5 @@
 #include "G4AdjointGamma.hh"
 
+
 ////////////////////////////////////////////////////////////////////////////////
 //
@@ -41,6 +45,13 @@
 
 { SetUseMatrix(false);
+  SetApplyCutInRange(false);
   current_eEnergy =0.;
   totAdjointCS=0.;
+  theAdjEquivOfDirectPrimPartDef =G4AdjointGamma::AdjointGamma();
+  theAdjEquivOfDirectSecondPartDef=G4AdjointElectron::AdjointElectron();
+  theDirectPrimaryPartDef=G4Gamma::Gamma();
+  second_part_of_same_type=false;
+  theDirectPEEffectModel = new G4PEEffectModel();
+ 
 }
 ////////////////////////////////////////////////////////////////////////////////
@@ -57,37 +68,22 @@
 
   //Compute the totAdjointCS vectors if not already done for the current couple and electron energy
+  //-----------------------------------------------------------------------------------------------
   const G4MaterialCutsCouple* aCouple = aTrack.GetMaterialCutsCouple();
   const G4DynamicParticle* aDynPart =  aTrack.GetDynamicParticle() ;
   G4double electronEnergy = aDynPart->GetKineticEnergy();
   G4ThreeVector electronDirection= aDynPart->GetMomentumDirection() ;
-  totAdjointCS = AdjointCrossSection(aCouple, electronEnergy,IsScatProjToProjCase);
+  pre_step_AdjointCS = totAdjointCS; //The last computed CS was  at pre step point
+  G4double adjCS;
+  adjCS = AdjointCrossSection(aCouple, electronEnergy,IsScatProjToProjCase);
+  post_step_AdjointCS = totAdjointCS; 
 				
- 
-  //Sample gamma energy
-  //-------------
-  	/////////////////////////////////////////////////////////////////////////////////
-//      Module:		G4ContinuousGainOfEnergy.hh
-//	Author:       	L. Desorgher
-//	Date:		1 September 2007
-// 	Organisation: 	SpaceIT GmbH
-// 	Customer:     	ESA/ESTEC
-/////////////////////////////////////////////////////////////////////////////////
-//
-// CHANGE HISTORY
-// --------------
-//      ChangeHistory: 
-//	 	1 September 2007 creation by L. Desorgher  		
-//
-//-------------------------------------------------------------
-//	Documentation:
-//		Modell for the adjoint compton scattering
-//
+
+
 
   //Sample element
   //-------------
    const G4ElementVector* theElementVector = currentMaterial->GetElementVector();
-   const G4double* theAtomNumDensityVector = currentMaterial->GetVecNbOfAtomsPerVolume();
    size_t nelm =  currentMaterial->GetNumberOfElements();
-   G4double rand_CS= totAdjointCS*G4UniformRand();
+   G4double rand_CS= G4UniformRand()*xsec[nelm-1];
    for (index_element=0; index_element<nelm-1; index_element++){
 	if (rand_CS<xsec[index_element]) break;
@@ -96,6 +92,6 @@
    //Sample shell and binding energy
    //-------------
-   rand_CS= totAdjointCS*G4UniformRand()/theAtomNumDensityVector[index_element];
    G4int nShells = (*theElementVector)[index_element]->GetNbOfAtomicShells();
+   rand_CS= shell_prob[index_element][nShells-1]*G4UniformRand();
    G4int i  = 0;  
    for (i=0; i<nShells-1; i++){
@@ -113,5 +109,5 @@
    G4double gamma   = 1. + electronEnergy/electron_mass_c2;
    if (gamma <= 5.) {
-  	G4double beta  = std::sqrt(gamma*gamma-1.)/gamma;
+  	G4double beta  = sqrt(gamma*gamma-1.)/gamma;
  	G4double b     = 0.5*gamma*(gamma-1.)*(gamma-2);
 
@@ -131,7 +127,7 @@
   
      
-  G4double sin_theta = std::sqrt(1.-cos_theta*cos_theta);
+  G4double sin_theta = sqrt(1.-cos_theta*cos_theta);
   G4double Phi     = twopi * G4UniformRand();
-  G4double dirx = sin_theta*std::cos(Phi),diry = sin_theta*std::sin(Phi),dirz = cos_theta;
+  G4double dirx = sin_theta*cos(Phi),diry = sin_theta*sin(Phi),dirz = cos_theta;
   G4ThreeVector adjoint_gammaDirection(dirx,diry,dirz);
   adjoint_gammaDirection.rotateUz(electronDirection);
@@ -141,5 +137,5 @@
   //Weight correction
  //-----------------------					   
-  CorrectPostStepWeight(fParticleChange, aTrack.GetWeight(), electronEnergy,gammaEnergy);	
+  CorrectPostStepWeight(fParticleChange, aTrack.GetWeight(), electronEnergy,gammaEnergy,IsScatProjToProjCase);	
  
   
@@ -149,11 +145,34 @@
   G4DynamicParticle* anAdjointGamma = new G4DynamicParticle (
                        G4AdjointGamma::AdjointGamma(),adjoint_gammaDirection, gammaEnergy);
+  
+  
+  
+ 
+  
   fParticleChange->ProposeTrackStatus(fStopAndKill);
-  fParticleChange->AddSecondary(anAdjointGamma);
-     
+  fParticleChange->AddSecondary(anAdjointGamma);    
      	
 
   
 
+}
+
+////////////////////////////////////////////////////////////////////////////////
+//
+void G4AdjointPhotoElectricModel::CorrectPostStepWeight(G4ParticleChange* fParticleChange, 
+							    G4double old_weight,  
+							    G4double adjointPrimKinEnergy, 
+							    G4double projectileKinEnergy ,
+							    G4bool  ) 
+{
+ G4double new_weight=old_weight;
+
+ G4double w_corr =G4AdjointCSManager::GetAdjointCSManager()->GetPostStepWeightCorrection()/factorCSBiasing;
+ w_corr*=post_step_AdjointCS/pre_step_AdjointCS; 
+ new_weight*=w_corr; 
+ new_weight*=projectileKinEnergy/adjointPrimKinEnergy;
+ fParticleChange->SetParentWeightByProcess(false);
+ fParticleChange->SetSecondaryWeightByProcess(false);
+ fParticleChange->ProposeParentWeight(new_weight);	
 }	
 
@@ -164,10 +183,15 @@
 				G4double electronEnergy,
 				G4bool IsScatProjToProjCase)
-{ if (IsScatProjToProjCase) return 0.;
+{ 
+  
+
+  if (IsScatProjToProjCase)  return 0.;
+
+  	
   if (aCouple !=currentCouple || current_eEnergy !=electronEnergy) {
   	totAdjointCS = 0.;
 	DefineCurrentMaterialAndElectronEnergy(aCouple, electronEnergy);
   	const G4ElementVector* theElementVector = currentMaterial->GetElementVector();
-  	const G4double* theAtomNumDensityVector = currentMaterial->GetVecNbOfAtomsPerVolume();
+  	const double* theAtomNumDensityVector = currentMaterial->GetVecNbOfAtomsPerVolume();
   	size_t nelm =  currentMaterial->GetNumberOfElements();
   	for (index_element=0;index_element<nelm;index_element++){
@@ -176,7 +200,14 @@
 		xsec[index_element] = totAdjointCS;
 	} 
-  }	
-  return totAdjointCS;
-  
+
+	totBiasedAdjointCS=std::min(totAdjointCS,0.01);
+//	totBiasedAdjointCS=totAdjointCS;
+	factorCSBiasing = totBiasedAdjointCS/totAdjointCS;
+	lastCS=totBiasedAdjointCS;
+  	
+	
+  }
+  return totBiasedAdjointCS;
+
   
 }
@@ -188,23 +219,26 @@
   G4int nShells = anElement->GetNbOfAtomicShells();
   G4double Z= anElement->GetZ();
-  G4double N= anElement->GetN();
   G4int i  = 0;  
   G4double B0=anElement->GetAtomicShell(0);
   G4double gammaEnergy = electronEnergy+B0;
-  G4double adjointCS = theDirectPEEffectModel->ComputeCrossSectionPerAtom(G4Gamma::Gamma(),gammaEnergy,Z,N,0.,0.)*electronEnergy/gammaEnergy; 
+  G4double CS= theDirectPEEffectModel->ComputeCrossSectionPerAtom(G4Gamma::Gamma(),gammaEnergy,Z,0.,0.,0.);
+  G4double adjointCS =0.;
+  if (CS >0) adjointCS += CS/gammaEnergy; 
   shell_prob[index_element][0] = adjointCS;                                          
   for (i=1;i<nShells;i++){
-  	//G4cout<<i<<std::endl;
+  	//G4cout<<i<<G4endl;
   	G4double Bi_= anElement->GetAtomicShell(i-1);
 	G4double Bi = anElement->GetAtomicShell(i);
-	//G4cout<<Bi_<<'\t'<<Bi<<std::endl;
+	//G4cout<<Bi_<<'\t'<<Bi<<G4endl;
 	if (electronEnergy <Bi_-Bi) {
 		gammaEnergy = electronEnergy+Bi;
-		adjointCS +=theDirectPEEffectModel->ComputeCrossSectionPerAtom(G4Gamma::Gamma(),gammaEnergy,anElement->GetZ(),N,0.,0.)*electronEnergy/gammaEnergy;
+		
+		CS=theDirectPEEffectModel->ComputeCrossSectionPerAtom(G4Gamma::Gamma(),gammaEnergy,Z,0.,0.,0.);
+		if (CS>0) adjointCS +=CS/gammaEnergy;
 	}
 	shell_prob[index_element][i] = adjointCS;	
   
   }
-  
+  adjointCS*=electronEnergy;
   return adjointCS;
   
Index: trunk/source/processes/electromagnetic/adjoint/src/G4ContinuousGainOfEnergy.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4ContinuousGainOfEnergy.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4ContinuousGainOfEnergy.cc	(revision 1196)
@@ -24,4 +24,7 @@
 // ********************************************************************
 //
+// $Id: G4ContinuousGainOfEnergy.cc,v 1.4 2009/11/20 10:31:20 ldesorgh Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
 #include "G4ContinuousGainOfEnergy.hh"
 #include "G4Step.hh"
@@ -31,4 +34,6 @@
 #include "G4VParticleChange.hh"
 #include "G4UnitsTable.hh"
+#include "G4AdjointCSManager.hh"
+#include "G4LossTableManager.hh"
 
 
@@ -38,4 +43,5 @@
   G4ProcessType type): G4VContinuousProcess(name, type)
 {
+
 
   linLossLimit=0.05;
@@ -44,4 +50,14 @@
   is_integral = false;
   
+  //Will be properly set in SetDirectParticle()
+  IsIon=false;
+  massRatio =1.;
+  chargeSqRatio=1.;
+  preStepChargeSqRatio=1.;
+
+  
+
+  
+  
 }
 
@@ -70,6 +86,18 @@
 }
 
-
-
+///////////////////////////////////////////////////////
+//
+void  G4ContinuousGainOfEnergy::SetDirectParticle(G4ParticleDefinition* p)
+{theDirectPartDef=p;
+ if (theDirectPartDef->GetParticleType()== "nucleus") {
+ 	 IsIon=true;
+	 massRatio = proton_mass_c2/theDirectPartDef->GetPDGMass();
+	 G4double q=theDirectPartDef->GetPDGCharge();
+	 chargeSqRatio=q*q;
+	
+	 
+ }
+ 
+}
 
 ///////////////////////////////////////////////////////
@@ -80,4 +108,11 @@
 {
    
+  //Caution in this method the  step length should be the true step length
+  // A problem is that this is compute by the multiple scattering that does not know the energy at the end of the adjoint step. This energy is used during the 
+  //Forward sim. Nothing we can really do against that at this time. This is inherent to the MS method
+  //
+  
+  
+  
   aParticleChange.Initialize(track);
   
@@ -86,15 +121,12 @@
   G4double length = step.GetStepLength();
   G4double degain  = 0.0;
- 
- 
- 
-
+  
+  
+ 
   // Compute this for weight change after continuous energy loss
   //-------------------------------------------------------------
-  G4double DEDX_before = 
-  		theDirectEnergyLossProcess
-				->GetDEDX(preStepKinEnergy, currentCouple);
- 
- 
+  G4double DEDX_before = theDirectEnergyLossProcess->GetDEDX(preStepKinEnergy, currentCouple);
+   
+  
   
   // For the fluctuation we generate a new dynamic particle with energy =preEnergy+egain
@@ -103,50 +135,96 @@
   G4DynamicParticle* dynParticle = new G4DynamicParticle();
   *dynParticle = *(track.GetDynamicParticle());
-  G4double Tkin = dynParticle->GetKineticEnergy();
-  
+  dynParticle->SetDefinition(theDirectPartDef);
+  G4double Tkin = dynParticle->GetKineticEnergy(); 
+  G4double Tkin1=Tkin*0.001;
+
   size_t n=1;
   if (is_integral ) n=10;
+  n=1;
   G4double dlength= length/n; 
   for (size_t i=0;i<n;i++) {
+  	G4double factor_dE=1.;
+	if (Tkin != preStepKinEnergy && IsIon) {
+  		chargeSqRatio =  currentModel->GetChargeSquareRatio(theDirectPartDef,currentMaterial,Tkin);
+		theDirectEnergyLossProcess->SetDynamicMassCharge(massRatio,chargeSqRatio); 
+	
+  	}
+  
   	G4double r = theDirectEnergyLossProcess->GetRange(Tkin, currentCouple);
    	if( dlength <= linLossLimit * r ) {
     		degain = DEDX_before*dlength;
+		G4double degain1 = dlength*theDirectEnergyLossProcess->GetDEDX(Tkin1, currentCouple);
+		factor_dE=1.+(degain1-degain)/(Tkin1-Tkin);
 	} 
   	else {
-    		G4double x = r + length;
-    		degain = theDirectEnergyLossProcess->GetKineticEnergy(x,currentCouple) - theDirectEnergyLossProcess->GetKineticEnergy(r,currentCouple);
+    		G4double x = r + dlength;
+    		//degain = theDirectEnergyLossProcess->GetKineticEnergy(x,currentCouple) - theDirectEnergyLossProcess->GetKineticEnergy(r,currentCouple);
+		G4double E = theDirectEnergyLossProcess->GetKineticEnergy(x,currentCouple);
+		if (IsIon){
+			chargeSqRatio =  currentModel->GetChargeSquareRatio(theDirectPartDef,currentMaterial,E);
+			theDirectEnergyLossProcess->SetDynamicMassCharge(massRatio,chargeSqRatio);
+			G4double x1= theDirectEnergyLossProcess->GetRange(E, currentCouple);
+			while (std::abs(x-x1)>0.01*x) {
+				E = theDirectEnergyLossProcess->GetKineticEnergy(x,currentCouple);
+				chargeSqRatio =  currentModel->GetChargeSquareRatio(theDirectPartDef,currentMaterial,E);
+				theDirectEnergyLossProcess->SetDynamicMassCharge(massRatio,chargeSqRatio);
+				x1= theDirectEnergyLossProcess->GetRange(E, currentCouple);
+			
+			} 
+		}
+		G4double r1 = theDirectEnergyLossProcess->GetRange(Tkin1, currentCouple);
+		G4double x1 = r1 + dlength;
+		G4double E1 = theDirectEnergyLossProcess->GetKineticEnergy(x1,currentCouple);
+		factor_dE=(E1-E)/(Tkin1-Tkin);
+		degain=E-Tkin;	
+		
+		
+		
   	}
-	G4VEmModel* currentModel =  theDirectEnergyLossProcess->SelectModelForMaterial(Tkin+degain,currentMaterialIndex);
+	//G4cout<<degain<<G4endl;
   	G4double tmax = currentModel->MaxSecondaryKinEnergy(dynParticle);
  	tmax = std::min(tmax,currentTcut);
- 
-  
+ 	
+	
+	dynParticle->SetKineticEnergy(Tkin+degain);
+
+	// Corrections, which cannot be tabulated for ions
+	//----------------------------------------
+	G4double esecdep=0;//not used in most models
+	currentModel->CorrectionsAlongStep(currentCouple, dynParticle, degain,esecdep, dlength); 
 
   	// Sample fluctuations
   	//-------------------
+	
   	
 	G4double deltaE =0.;
   	if (lossFluctuationFlag ) {
       		deltaE = currentModel->GetModelOfFluctuations()->
-      						SampleFluctuations(currentMaterial,dynParticle,tmax,length,degain)-degain;
+      						SampleFluctuations(currentMaterial,dynParticle,tmax,dlength,degain)-degain;
   	}
-	Tkin+=degain+deltaE;
+	
+	G4double egain=degain+deltaE;
+	if (egain <=0) egain=degain;
+	Tkin+=egain;
 	dynParticle->SetKineticEnergy(Tkin);
-  	
+ }
+ 
+ 
+  
+
+  
+  delete dynParticle;
+ 
+  if (IsIon){
+	chargeSqRatio =  currentModel->GetChargeSquareRatio(theDirectPartDef,currentMaterial,Tkin);
+	theDirectEnergyLossProcess->SetDynamicMassCharge(massRatio,chargeSqRatio);
+		
   }
- 
-  
-
-  // Corrections, which cannot be tabulated 
-  // probably  this should be also changed
-  // at this time it does nothing so we can leave it
-  //CorrectionsAlongStep(currentCouple, dynParticle, egain, length);
-  
-  delete dynParticle;
- 
   
   G4double DEDX_after = theDirectEnergyLossProcess->GetDEDX(Tkin, currentCouple);
-  G4double weight_correction=DEDX_after/DEDX_before; //probably not needed
-  weight_correction=1.;
+  
+  
+  G4double weight_correction=DEDX_after/DEDX_before;
+ 
   
   aParticleChange.ProposeEnergy(Tkin);
@@ -154,5 +232,5 @@
   //we still need to register in the particleChange the modification of the weight of the particle 
   G4double new_weight=weight_correction*track.GetWeight();
-  aParticleChange.SetParentWeightByProcess(true);
+  aParticleChange.SetParentWeightByProcess(false);
   aParticleChange.ProposeParentWeight(new_weight);
   
@@ -168,2 +246,66 @@
   lossFluctuationFlag = val;
 }
+///////////////////////////////////////////////////////
+//
+
+
+
+G4double G4ContinuousGainOfEnergy::GetContinuousStepLimit(const G4Track& track,
+                G4double , G4double , G4double& )
+{ 
+  G4double x = DBL_MAX;
+  x=.1*mm;
+ 
+ 
+  DefineMaterial(track.GetMaterialCutsCouple());
+ 
+  preStepKinEnergy = track.GetKineticEnergy(); 
+  preStepScaledKinEnergy = track.GetKineticEnergy()*massRatio;
+  currentModel = theDirectEnergyLossProcess->SelectModelForMaterial(preStepScaledKinEnergy,currentCoupleIndex);
+  G4double emax_model=currentModel->HighEnergyLimit();
+  if (IsIon) {
+  	chargeSqRatio =  currentModel->GetChargeSquareRatio(theDirectPartDef,currentMaterial,preStepKinEnergy);
+	preStepChargeSqRatio = chargeSqRatio;
+	theDirectEnergyLossProcess->SetDynamicMassCharge(massRatio,preStepChargeSqRatio);
+  } 
+  
+  
+  G4double maxE =1.1*preStepKinEnergy;
+  /*if (preStepKinEnergy< 0.05*MeV) maxE =2.*preStepKinEnergy;
+  else if (preStepKinEnergy< 0.1*MeV) maxE =1.5*preStepKinEnergy;
+  else if (preStepKinEnergy< 0.5*MeV) maxE =1.25*preStepKinEnergy;*/
+   
+  if (preStepKinEnergy < currentTcut) maxE = std::min(currentTcut,maxE);
+ 
+  maxE=std::min(emax_model*1.001,maxE);
+  	
+  G4double r = theDirectEnergyLossProcess->GetRange(preStepKinEnergy, currentCouple);
+  
+  if (IsIon) {
+  	G4double chargeSqRatioAtEmax = currentModel->GetChargeSquareRatio(theDirectPartDef,currentMaterial,maxE);
+	theDirectEnergyLossProcess->SetDynamicMassCharge(massRatio,chargeSqRatioAtEmax);
+  }	
+  
+  G4double r1 = theDirectEnergyLossProcess->GetRange(maxE, currentCouple);
+  
+  if (IsIon) theDirectEnergyLossProcess->SetDynamicMassCharge(massRatio,preStepChargeSqRatio);
+  
+  
+
+  x=r1-r;
+  x=std::max(r1-r,0.001*mm);
+ 
+  return x;
+  
+ 
+}
+#include "G4EmCorrections.hh"
+///////////////////////////////////////////////////////
+//
+
+void G4ContinuousGainOfEnergy::SetDynamicMassCharge(const G4Track& ,G4double energy)
+{ 
+
+  G4double ChargeSqRatio= G4LossTableManager::Instance()->EmCorrections()->EffectiveChargeSquareRatio(theDirectPartDef,currentMaterial,energy); 
+  if (theDirectEnergyLossProcess) theDirectEnergyLossProcess->SetDynamicMassCharge(massRatio,ChargeSqRatio);
+}
Index: trunk/source/processes/electromagnetic/adjoint/src/G4InversePEEffect.cc
===================================================================
--- trunk/source/processes/electromagnetic/adjoint/src/G4InversePEEffect.cc	(revision 966)
+++ trunk/source/processes/electromagnetic/adjoint/src/G4InversePEEffect.cc	(revision 1196)
@@ -24,4 +24,7 @@
 // ********************************************************************
 //
+// $Id: G4InversePEEffect.cc,v 1.4 2009/11/20 10:31:20 ldesorgh Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
+//
 #include "G4InversePEEffect.hh"
 #include "G4VEmAdjointModel.hh"
@@ -31,7 +34,10 @@
 //
 G4InversePEEffect::G4InversePEEffect(G4String process_name,G4AdjointPhotoElectricModel* aModel):
-				G4VAdjointInverseScattering(process_name,false)
+				G4VAdjointReverseReaction(process_name,false)
 {theAdjointEMModel = aModel;
- theAdjointEMModel->SetSecondPartOfSameType(false); 
+ theAdjointEMModel->SetSecondPartOfSameType(false);
+ SetIntegralMode(false);
+  
+ 
 }
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
